# -*- coding: utf-8  -*-

#Appel des bibliothèques 
import pywikibot
import MySQLdb 

#Connexion à MySQL
db = MySQLdb.Connect(host="127.0.0.1", port=3306, user="root", passwd="", db="dbwiki")
Cursor = db.cursor()

#Requête recherche des enregistrements 
sql = "SELECT id,uri_db FROM artworks WHERE Qwikidata=''"

#Exécution de la requête
Cursor.execute(sql)
results = Cursor.fetchall()

#Choix de la version de Wikipédia selon la langue
site = pywikibot.Site("fr", "wikipedia")

#Parcours des résulats
for result in results:
    
    #On récupère juste le nom de page
    nompage=result[1].decode('utf8').replace("http://fr.dbpedia.org/resource/","")
    
    #Cération de l'objet page
    page = pywikibot.Page(site,nompage)
    
    #Récupération des données si la page existe sur Wikidata
    data = pywikibot.DataPage(page)
    
    #Si la page existe
    if data.exists():
    
        #Récupération des données Wikidata
        dic=data.get()
        
        #Récupération de l'identifiant Wikidata (QXXXXX)
        qwd=str(data).replace("[[wikidata:","").replace("]]","")
        
        #Requête d'enregistrement de l'identifiant Wikidata
        Cursor.execute("UPDATE artworks SET Qwikidata=%s WHERE id=%s",(qwd,result[0]))
        
        #Soumission de l'enregistrement à la base MySQL
        db.commit()
        
        print str(result[0])+" item Wikidata"
    else:
        print str(result[0])+" pas d'item Wikidata"

#Fermeture de la connexion MySQL
Cursor.close ()
db.close()

