# -*- coding: utf-8  -*-

#Appel des bibliothèques 
import pywikibot
import MySQLdb 

#Fonction pour vérifier la présence d'une propriété donnée dans un item Wikidata
def testprop(prop,claims):
    trouve=False
    for datatmp in claims:
        if str(datatmp['m'][1])==prop:
            trouve=True
            break
    return trouve

#Connexion à MySQL
db = MySQLdb.Connect(host="127.0.0.1", port=3306, user="root", passwd="", db="dbwiki")
Cursor = db.cursor()

#Requête de recherche des enregistrements validés
sql = "SELECT id,uri_db FROM artworks WHERE is_artwork=1 and img_correct=1 and img_exists=1"

#Exécution de la requête
Cursor.execute(sql)
results = Cursor.fetchall()

#Choix de la version de Wikipédia selon la langue
site = pywikibot.Site("fr", "wikipedia")

#Parcours des résulats
for result in results:
    id = str(result[0])
    
    #On récupère juste le nom de page
    nompage=result[1].decode('utf8').replace("http://fr.dbpedia.org/resource/","")
    
    #Cération de l'objet page
    page = pywikibot.Page(site,nompage)
    
    #Récupération des données si la page existe sur Wikidata
    data = pywikibot.DataPage(page)
    
    #Si la page existe
    if data.exists():
    
        #Récupération des données Wikidata
        dic=data.get()
        
        #Test pour savoir si l'item a déjà la propriété image (p18) renseignée
        p18_exists=testprop('18',dic['claims'])

        #Si une image est déjà indiquée 
        if p18_exists:
            print id+" image existe"
        #Sinon on publie la donnée
        else:
            print id+" image"
            
            #Remplacement des "_" par " " 
            image=result[2].decode('utf8').replace("_"," ")
            
            #Publication sur Wikidata
            # en indiquant que la donnée est importée de Wikipedia-fr (Q8447)
            data.editclaim("p18",image,refs={("p143","Q8447")})
    else:
        print id+" pas d'item Wikidata"


